HUD 1828 Picture 矩形周长/线段树

2024-04-23 20:32

本文主要是介绍HUD 1828 Picture 矩形周长/线段树,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题意:求重叠矩形的周长。
题解:枚举x区间时要注意求出, y 轴投影的线段数量。 即对应一个 x 有多少段不连续的线段,因为这关系的矩形的宽。 对 x 进行排列要记得入边在前,出边在后,否则边相交的两个矩形,就会把重边也计算在内。


#include <cmath>
#include <algorithm>
#include <iostream>
using namespace std;
#define L(x) ( x << 1 )  
#define R(x) ( x << 1 | 1 )  
#define N 20010
int y[N*2];
struct Node 
{
int l, r, len, lc, rc, cover, cnt; /* lc, rc, 表示定的被覆盖的次数 */
} node[N*4];
struct Line
{
int x, y1, y2, flag;
} line[N*2];
bool cmp ( Line a, Line b )
{
if ( a.x != b.x )
return a.x < b.x;
return a.flag > b.flag; /* 当 x 相同时应当是入边在前, 画两个矩形分析分析 */
}
void y_update ( int u )
{
if ( node[u].cover > 0 )
node[u].len = y[node[u].r] - y[node[u].l];
else if ( node[u].l + 1 == node[u].r )
node[u].len = 0;
else
node[u].len = node[L(u)].len + node[R(u)].len;
if ( node[u].cover > 0 )
node[u].cnt = 1; /* cnt 记录投影到 y 轴上的线段数( 即不连续的段数) */
else
{
node[u].cnt = node[L(u)].cnt + node[R(u)].cnt;
if ( node[R(u)].lc != 0 && node[L(u)].rc != 0 )  
/*左子树的右端点如果跟右子树的左端点都被覆盖了,说明在整个区间里,有一个区间横跨左右子树,但被重复计算了,所以要减去1 */
node[u].cnt--;
}
}
void build( int u, int l, int r )
{
node[u].l = l;   
node[u].r = r;
node[u].cnt = 0;
node[u].len = node[u].cover = 0;
node[u].lc = node[u].rc = 0;
if ( l + 1 == r ) return;
int mid = ( l + r ) >> 1;
build ( L(u), l, mid );
build ( R(u), mid, r );
}
void update ( int u, Line e )
{  
if ( e.y1 == y[node[u].l] )
node[u].lc += e.flag;
if ( e.y2 == y[node[u].r] )
node[u].rc += e.flag;
if ( e.y1 == y[node[u].l] && e.y2 == y[node[u].r] )
{
node[u].cover += e.flag; 
y_update ( u );
return;
}
if ( e.y1 >= y[node[R(u)].l] )
update ( R(u), e );
else if ( e.y2 <= y[node[L(u)].r] )
update ( L(u), e );
else
{
Line temp1 = e;
Line temp2 = e;
temp1.y2 = y[node[L(u)].r];
temp2.y1 = y[node[R(u)].l];
update ( L(u), temp1 );
update ( R(u), temp2 );
}
y_update ( u );
}
int main()
{
//freopen ( "a.txt", "r", stdin );
int n, i, k, x1, y1, x2, y2;
while ( scanf("%d",&n) != EOF )
{
for ( i = k = 1; i <= n; i++, k++ )
{
scanf("%d %d %d %d", &x1, &y1, &x2, &y2 );
line[k].x = x1;
line[k].y1 = y1;
line[k].y2 = y2;
line[k].flag = 1;
y[k] = y1;
k++;
line[k].x = x2;
line[k].y1 = y1;
line[k].y2 = y2;
line[k].flag = -1;
y[k] = y2;
}
sort ( line+1, line+k, cmp );
sort ( y+1, y+k );
build ( 1, 1, k-1 );
update ( 1, line[1] );
int ans = node[1].len;
int temp = node[1].len;
int tcnt = node[1].cnt;
for ( i = 2; i < k; i++ )
{
update ( 1, line[i] );
ans += abs ( node[1].len - temp );
ans += 2 * ( line[i].x - line[i-1].x ) * tcnt;
temp = node[1].len;
tcnt = node[1].cnt;
}
printf ( "%d\n", ans );
}
return 0;
}


这篇关于HUD 1828 Picture 矩形周长/线段树的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/929813

相关文章

poj3468(线段树成段更新模板题)

题意:包括两个操作:1、将[a.b]上的数字加上v;2、查询区间[a,b]上的和 下面的介绍是下解题思路: 首先介绍  lazy-tag思想:用一个变量记录每一个线段树节点的变化值,当这部分线段的一致性被破坏我们就将这个变化值传递给子区间,大大增加了线段树的效率。 比如现在需要对[a,b]区间值进行加c操作,那么就从根节点[1,n]开始调用update函数进行操作,如果刚好执行到一个子节点,

hdu1394(线段树点更新的应用)

题意:求一个序列经过一定的操作得到的序列的最小逆序数 这题会用到逆序数的一个性质,在0到n-1这些数字组成的乱序排列,将第一个数字A移到最后一位,得到的逆序数为res-a+(n-a-1) 知道上面的知识点后,可以用暴力来解 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#in

hdu1689(线段树成段更新)

两种操作:1、set区间[a,b]上数字为v;2、查询[ 1 , n ]上的sum 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdl

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

poj 1127 线段相交的判定

题意: 有n根木棍,每根的端点坐标分别是 px, py, qx, qy。 判断每对木棍是否相连,当他们之间有公共点时,就认为他们相连。 并且通过相连的木棍相连的木棍也是相连的。 解析: 线段相交的判定。 首先,模板中的线段相交是不判端点的,所以要加一个端点在直线上的判定; 然后,端点在直线上的判定这个函数是不判定两个端点是同一个端点的情况的,所以要加是否端点相等的判断。 最后

HDU4737线段树

题目大意:给定一系列数,F(i,j)表示对从ai到aj连续求或运算,(i<=j)求F(i,j)<=m的总数。 const int Max_N = 100008 ;int sum[Max_N<<2] , x[Max_N] ;int n , m ;void push_up(int t){sum[t] = sum[t<<1] | sum[t<<1|1] ;}void upd

zoj 1721 判断2条线段(完全)相交

给出起点,终点,与一些障碍线段。 求起点到终点的最短路。 枚举2点的距离,然后最短路。 2点可达条件:没有线段与这2点所构成的线段(完全)相交。 const double eps = 1e-8 ;double add(double x , double y){if(fabs(x+y) < eps*(fabs(x) + fabs(y))) return 0 ;return x + y ;

圆与线段的交点

poj 3819  给出一条线段的两个端点,再给出n个圆,求出这条线段被所有圆覆盖的部分占了整条线段的百分比。 圆与线段的交点 : 向量AB 的参数方程  P = A + t * (B - A)      0<=t<=1 ; 将点带入圆的方程即可。  注意: 有交点 0 <= t <= 1 ; 此题求覆盖的部分。 则 若求得 t  满足 ; double ask(d

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja